package com.cipherlab.rfidscansample;


import java.io.File;
import java.io.IOException;

import com.cipherlab.rfid.AllGen2Settings;
import com.cipherlab.rfid.AllQValue;
import com.cipherlab.rfid.AllRFLink;
import com.cipherlab.rfid.AuthenticateIncRepLen;
import com.cipherlab.rfid.AuthenticateSenRep;
import com.cipherlab.rfid.BeepType;
import com.cipherlab.rfid.ClResult;
import com.cipherlab.rfid.DeviceEvent;
import com.cipherlab.rfid.DeviceInfo;
import com.cipherlab.rfid.DeviceResponse;
import com.cipherlab.rfid.DeviceVoltageInfo;
import com.cipherlab.rfid.EPCEncodingScheme;
import com.cipherlab.rfid.Enable_State;
import com.cipherlab.rfid.FWUpdateErrorCode;
import com.cipherlab.rfid.Gen2Settings;
import com.cipherlab.rfid.GeneralString;
import com.cipherlab.rfid.InventoryStatusSettings;
import com.cipherlab.rfid.InventoryType;
import com.cipherlab.rfid.JapanChannel;
import com.cipherlab.rfid.LockTarget;
import com.cipherlab.rfid.ModuleTemperature;
import com.cipherlab.rfid.NotificationParams;
import com.cipherlab.rfid.QValue;
import com.cipherlab.rfid.RFIDMemoryBank;
import com.cipherlab.rfid.RFIDMode;
import com.cipherlab.rfid.RFLink;
import com.cipherlab.rfid.RfidEpcFilter;
import com.cipherlab.rfid.RfidOutputConfiguration;
import com.cipherlab.rfid.SLFlagSettings;
import com.cipherlab.rfid.ScanMode;
import com.cipherlab.rfid.SessionSettings;
import com.cipherlab.rfid.UntraceableRange;
import com.cipherlab.rfid.UntraceableTID;
import com.cipherlab.rfid.UntraceableU;
import com.cipherlab.rfid.UntraceableUser;
import com.cipherlab.rfid.WorkMode;
import com.cipherlab.rfidapi.RfidManager;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.MediaPlayer;
import android.media.MediaPlayer.OnCompletionListener;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.InputDevice;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {
	
	RfidManager mRfidManager = null;
	String TAG = "RFID_sample";
	TextView tv1 = null;
	//EditText e1 = null;
	Button b1 = null;
	CheckBox mCheckBox_SwitchStatus = null;
	CheckBox mCheckBox_ScanMode = null;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		mRfidManager = RfidManager.InitInstance(this);
		
		IntentFilter filter = new IntentFilter();
		filter.addAction(GeneralString.Intent_RFIDSERVICE_CONNECTED);
		filter.addAction(GeneralString.Intent_RFIDSERVICE_TAG_DATA);
		filter.addAction(GeneralString.Intent_RFIDSERVICE_EVENT);
		filter.addAction(GeneralString.Intent_FWUpdate_ErrorMessage);
		filter.addAction(GeneralString.Intent_FWUpdate_Percent);
		filter.addAction(GeneralString.Intent_FWUpdate_Finish);
		filter.addAction(GeneralString.Intent_GUN_Attached);
		filter.addAction(GeneralString.Intent_GUN_Unattached);
		filter.addAction(GeneralString.Intent_GUN_Power);
		registerReceiver(myDataReceiver, filter);		
		
		//e1 = (EditText) findViewById(R.id.editText1);
		
		tv1 = (TextView) findViewById(R.id.textView1);
		
		mCheckBox_SwitchStatus = (CheckBox) findViewById(R.id.checkBox1);
		mCheckBox_ScanMode = (CheckBox) findViewById(R.id.checkBox2);
		
		b1= (Button) findViewById(R.id.button1);
		b1.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

			}
		});

		mCheckBox_SwitchStatus.setOnCheckedChangeListener(new CheckBox.OnCheckedChangeListener() 
		{
					@Override
					public void onCheckedChanged(CompoundButton buttonView,boolean isChecked) 
					{
						if(isChecked)
						{
							int re = mRfidManager.SetRFIDSwitchStatus(true);
							if(re!=ClResult.S_OK.ordinal())
							{
								String err = mRfidManager.GetLastError();
								Log.e(TAG, "SetRFIDSwitchStatus true (err) = " + err);
							}
							else
							{
								mCheckBox_SwitchStatus.setText("RFID");
							}
						}
						else
						{
							int re = mRfidManager.SetRFIDSwitchStatus(false);
							if(re!=ClResult.S_OK.ordinal())
							{
								String err = mRfidManager.GetLastError();
								Log.e(TAG, "SetRFIDSwitchStatus false (err) = " + err);
							}
							else
							{
								mCheckBox_SwitchStatus.setText("Reader");
							}
						}
					}

				});
		
		mCheckBox_ScanMode.setOnCheckedChangeListener(new CheckBox.OnCheckedChangeListener() 
		{
					@Override
					public void onCheckedChanged(CompoundButton buttonView,boolean isChecked) 
					{
						if(isChecked)
						{
							int re = 0;
							re = mRfidManager.SetScanMode(ScanMode.Continuous);

							if(re!=ClResult.S_OK.ordinal())
							{
								String m = mRfidManager.GetLastError();
				                Log.e(TAG, "SetScanMode Continuous GetLastError = " + m);
							}
							else
							{
								mCheckBox_ScanMode.setText("Continuous");
							}
						}
						else
						{
							int re = 0;
							re = mRfidManager.SetScanMode(ScanMode.Single);
							
							if(re!=ClResult.S_OK.ordinal())
							{
								String m = mRfidManager.GetLastError();
				                Log.e(TAG, "SetScanMode Single GetLastError = " + m);
							}
							else
							{
								mCheckBox_ScanMode.setText("Single");
							}
						}
						
					}

				});
	}
	
	public void ForTest()
	  {
		try {
            DeviceInfo info = mRfidManager.GetDeviceInfo();
            String m = mRfidManager.GetLastError();
            Log.e(TAG, "GetLastError = " + m);
            Log.w(TAG, "deviceInfo.SerialNumber = " + info.SerialNumber );
            Log.w(TAG, "deviceInfo.Region = " + info.Region );
            Log.w(TAG, "deviceInfo.KernelVersion = " + info.KernelVersion );
            Log.w(TAG, "deviceInfo.UserVersion = " + info.UserVersion );
            Log.w(TAG, "deviceInfo.RFIDModuleVersion = " + info.RFIDModuleVersion );
        }catch (Exception e) {
            e.printStackTrace();
            Log.e(TAG, "Exception = " + e.getMessage());
        }
	  }
	


	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		
		unregisterReceiver(myDataReceiver);
		
		mRfidManager.Release();
	}
	
	private final BroadcastReceiver myDataReceiver = new BroadcastReceiver() 
	{
		@Override
		public void onReceive(Context context, Intent intent) {
			if (intent.getAction().equals(GeneralString.Intent_RFIDSERVICE_CONNECTED)) 
			{
				String PackageName = intent.getStringExtra("PackageName");
				
				// / make sure this AP does already connect with RFID service (after call RfidManager.InitInstance(this)
				String ver = "";
				ver = mRfidManager.GetServiceVersion();
				String api_ver = mRfidManager.GetAPIVersion();
				tv1.setText(PackageName + "," + ver + " , " + api_ver);
				
				if(mRfidManager.GetConnectionStatus())
				{
					mCheckBox_SwitchStatus.setVisibility(View.VISIBLE);
					mCheckBox_ScanMode.setVisibility(View.VISIBLE);
					b1.setVisibility(View.GONE);
					
					int mStatus = mRfidManager.GetRFIDSwitchStatus();
					if (mStatus!=-1) 
					{
						Log.i(TAG, "GetRFIDSwitchStatus = " + mStatus);
						if(mStatus==1)
						{
							mCheckBox_SwitchStatus.setChecked(true);
							mCheckBox_SwitchStatus.setText("RFID");
						}
						else if(mStatus==0)
						{
							mCheckBox_SwitchStatus.setChecked(false);
							mCheckBox_SwitchStatus.setText("Reader");
						}
							
					} 
					else 
					{
						String m = mRfidManager.GetLastError();
						Log.e(TAG, "GetLastError = " + m);
					}
					
					ScanMode mode =  mRfidManager.GetScanMode();
					if(mode == ScanMode.Err)
					{
						String m = mRfidManager.GetLastError();
		                Log.e(TAG, "GetLastError = " + m);
					}
					else
					{
						Log.i(TAG, "GetScanMode = " + mode );
						if(mode==ScanMode.Continuous)
						{
							mCheckBox_ScanMode.setChecked(true);
							mCheckBox_ScanMode.setText("Continuous");
						}
						else if(mode==ScanMode.Single)
						{
							mCheckBox_ScanMode.setChecked(false);
							mCheckBox_ScanMode.setText("Single");
						}
						else if(mode==ScanMode.Alternate)
						{
							mCheckBox_ScanMode.setChecked(false);
							mCheckBox_ScanMode.setText("Alternate");
						}
						else
						{
							mCheckBox_ScanMode.setChecked(false);
						}
					}
					
					
				}
				else
				{
					mCheckBox_SwitchStatus.setVisibility(View.GONE);
					mCheckBox_ScanMode.setVisibility(View.GONE);
					b1.setVisibility(View.GONE);
				}

				
				
				Toast.makeText(MainActivity.this,  "Intent_RFIDSERVICE_CONNECTED", Toast.LENGTH_SHORT).show();
			}
			else if(intent.getAction().equals(GeneralString.Intent_RFIDSERVICE_TAG_DATA))
			{
				/* 
				 * type : 0=Normal scan (Press Trigger Key to receive the data) ; 1=Inventory EPC ; 2=Inventory ECP TID ; 3=Reader tag ; 5=Write tag ; 6=Lock tag ; 7=Kill tag ; 8=Authenticate tag ; 9=Untraceable tag
				 * response : 0=RESPONSE_OPERATION_SUCCESS ; 1=RESPONSE_OPERATION_FINISH ; 2=RESPONSE_OPERATION_TIMEOUT_FAIL ; 6=RESPONSE_PASSWORD_FAIL ; 7=RESPONSE_OPERATION_FAIL ;251=DEVICE_BUSY
				 * */
				
				int type = intent.getIntExtra(GeneralString.EXTRA_DATA_TYPE, -1);
				int response = intent.getIntExtra(GeneralString.EXTRA_RESPONSE, -1);
				double data_rssi = intent.getDoubleExtra(GeneralString.EXTRA_DATA_RSSI, 0);
				
				String PC = intent.getStringExtra(GeneralString.EXTRA_PC);
				String EPC = intent.getStringExtra(GeneralString.EXTRA_EPC);
				String TID = intent.getStringExtra(GeneralString.EXTRA_TID);
				String ReadData = intent.getStringExtra(GeneralString.EXTRA_ReadData);
				int EPC_length = intent.getIntExtra(GeneralString.EXTRA_EPC_LENGTH, 0);
				int TID_length = intent.getIntExtra(GeneralString.EXTRA_TID_LENGTH, 0);
				int ReadData_length = intent.getIntExtra(GeneralString.EXTRA_ReadData_LENGTH, 0);
				
				String Data = "response = " + response + " , EPC = " + EPC + "\r TID = " + TID;

				tv1.setText(Data);
				//e1.setText(EPC);
				Log.w(TAG, "++++ [Intent_RFIDSERVICE_TAG_DATA] ++++");
				Log.d(TAG, "[Intent_RFIDSERVICE_TAG_DATA] type=" + type + ", response=" + response + ", data_rssi="+data_rssi   );
				Log.d(TAG, "[Intent_RFIDSERVICE_TAG_DATA] PC=" + PC );
				Log.d(TAG, "[Intent_RFIDSERVICE_TAG_DATA] EPC=" + EPC );
				Log.d(TAG, "[Intent_RFIDSERVICE_TAG_DATA] EPC_length=" + EPC_length );
				Log.d(TAG, "[Intent_RFIDSERVICE_TAG_DATA] TID=" + TID );
				Log.d(TAG, "[Intent_RFIDSERVICE_TAG_DATA] TID_length=" + TID_length );
				Log.d(TAG, "[Intent_RFIDSERVICE_TAG_DATA] ReadData=" + ReadData );
				Log.d(TAG, "[Intent_RFIDSERVICE_TAG_DATA] ReadData_length=" + ReadData_length );
				
				// If type=8 ; Authenticate response data in ReadData
				if(type==GeneralString.TYPE_AUTHENTICATE_TAG && response==GeneralString.RESPONSE_OPERATION_SUCCESS)
				{
					Log.i(TAG, "Authenticate response data=" + ReadData );
				}
			}
			
			//Intent_RFIDSERVICE_EVENT
			else if(intent.getAction().equals(GeneralString.Intent_RFIDSERVICE_EVENT))
			{
				int event  = intent.getIntExtra(GeneralString.EXTRA_EVENT_MASK, -1);
				Log.d(TAG, "[Intent_RFIDSERVICE_EVENT] DeviceEvent=" + event );
				if(event == DeviceEvent.LowBattery.getValue())
				{
					Log.i(GeneralString.TAG, "LowBattery " );
				}
				else if(event == DeviceEvent.PowerSavingMode.getValue() )
				{
					Log.i(GeneralString.TAG, "PowerSavingMode " );
				}
				else if(event == DeviceEvent.OverTemperature.getValue())
				{
					Log.i(GeneralString.TAG, "OverTemperature " );
					
				}
				else if(event == DeviceEvent.ScannerFailure.getValue())
				{
					Log.i(GeneralString.TAG, "ScannerFailure " );
				}
				
			}
			else if(intent.getAction().equals(GeneralString.Intent_FWUpdate_ErrorMessage))
			{
				String mse = "";
				mse = intent.getStringExtra(GeneralString.FWUpdate_ErrorMessage);
				int errorcode = intent.getIntExtra(GeneralString.FWUpdate_ErrorCode,-1);
				if(mse!=null)
				{
					Log.d(TAG,  "FWUpdate Error : " + mse  + "(" + errorcode+")");
					Toast.makeText(MainActivity.this,  mse, Toast.LENGTH_SHORT).show();
					
					if(errorcode==FWUpdateErrorCode.SameVersion.getValue())
					{
						Log.d(TAG,  "SameVersion");
					}
				}
				Log.d(TAG,  "Intent_FWUpdate_ErrorMessage" );
			}
			else if(intent.getAction().equals(GeneralString.Intent_FWUpdate_Percent))
			{
				int i = intent.getIntExtra(GeneralString.FWUpdate_Percent,0);
				if(i>=0)
				{
					tv1.setText( Integer.toString(i));
				}
				Log.d(TAG,  "Intent_FWUpdate_Percent" );
			}
			else if(intent.getAction().equals(GeneralString.Intent_FWUpdate_Finish))
			{
				Log.d(TAG,  "Intent_FWUpdate_Finish" );
				Toast.makeText(MainActivity.this,  "Intent_FWUpdate_Finish", Toast.LENGTH_SHORT).show();
			}
			else if(intent.getAction().equals(GeneralString.Intent_GUN_Attached))
			{
				Log.d(TAG,  "Intent_GUN_Attached" );
				Toast.makeText(MainActivity.this,  "Intent_GUN_Attached", Toast.LENGTH_SHORT).show();
				mCheckBox_SwitchStatus.setVisibility(View.VISIBLE);
				mCheckBox_ScanMode.setVisibility(View.VISIBLE);
				b1.setVisibility(View.GONE);
			}
			else if(intent.getAction().equals(GeneralString.Intent_GUN_Unattached))
			{
				Log.d(TAG,  "Intent_GUN_Unattached" );
				Toast.makeText(MainActivity.this,  "Intent_GUN_Unattached", Toast.LENGTH_SHORT).show();
				mCheckBox_SwitchStatus.setVisibility(View.GONE);
				mCheckBox_ScanMode.setVisibility(View.GONE);
				b1.setVisibility(View.GONE);
			}
			else if(intent.getAction().equals(GeneralString.Intent_GUN_Power))
			{
				Log.d(TAG,  "Intent_GUN_Power" );
				boolean AC = intent.getBooleanExtra(GeneralString.Data_GUN_ACPower, false);
				boolean Connect = intent.getBooleanExtra(GeneralString.Data_GUN_Connect, false);
			}
			
		}
	};

}
